# ------------------------------------------------------------------
#
# ---------------------------------------------------
# copyright 2000 by voxeo corporation. (see LGPL.txt)
#
# v1.0 Coded in PERL
# v1.0 Coded by Stephen J. Lewis
# ---------------------------------------------------
#
# Requires:
#     CGI.pm
#
# This file requires the following audio files to run effectively:
#		VoicemailUnavailable.wav
#		DefaultGreeting.wav
#		MainMessage.wav
#		YourMessageHasBeenSaved.wav
#		GetPIN.wav
#		YouHaveTakenTooMuchTime.wav
#		AdminMenu.wav
#		HangingUp.wav
#		InvalidPIN.wav
#		MessageMenu.wav
#		NoNewMessages.wav
#		NoSavedMessages.wav
#		MessagesUndeleted.wav
#		MessageSaved.wav
#		MessageDeleted.wav
#		ChangePIN.wav
#       YouHaveEnteredPIN.wav
#		KeepThisPIN.wav
#       PINHasBeenChanged.wav
#		ChangeGreeting.wav
# 		YouHaveEnteredGreeting.wav
#		KeepThisGreeting.wav
#		GreetingFileHasBeenChanged.wav
# 
# Current default audio setting is PCM, 8khz, 8-bit mono, unsigned (.wav)
#						-----------
# This script also requires a user folder for the called id
# to exist along with a small user.ini file.  That user.ini
# will have between 2 and x number of lines.  It might look
# something like this:
#
# 	Greeting file:Greeting5551234.wav
# 	PIN code:1111
# 	Voicemail message:1:Read
# 	Voicemail message:2:Saved
# 	Voicemail message:3:Read
#
# Note that currently spaces should not be included, nor
# should there be any variance in the upper and lowercase
# lettering.
#						-----------
# As a general note to expert PERL coders out there, this 
# was the first PERL script I ever attempted; however, that
# stands as testimony to the flexibility and ease of voxeo's
# telephony solution.  
# -----------------------------------------------------------------

print "Content-type: text/html\n\n";

#----------------------------------------------------------
# These are the path variables used throughout the script.
# Changing these to whatever is appropriate allows for
# easy transport to different machines.  As stated above,
# there still needs to be a folder for each voicemail box
# number beneath the "users" sub-directory and a "user.ini"
# in that directory.
#
# Note that the "RecordPath" variable below was needed 
# because at the time of coding, the <recordaudio> CallXML
# element could not take an ftp address.  This is expected 
# to change in the near future.
#----------------------------------------------------------

$AudioPath  = "http://appserverdev.voxeo.com/jumpstart/voicemail/audio/";
$Voicemail  = "http://appserverdev.voxeo.com/jumpstart/voicemail/voicemail.pl";
$RecordPath = "appserverdev.voxeo.com/applications/voicemail/users/";
$FilePath   = "c:/program files/war-ftpd/FTPRoot/applications/voicemail/users/";

#-------------------------------------------------------------
# Change the values below if you want to use username/password
# requests.  Then simply tack them onto the beginning of you
# HTTP and FTP requests inside the code.
#-------------------------------------------------------------

$HTTPUsername = "";
$HTTPPassword = "";
$FTPUsername  = "opensource";
$FTPPassword  = "pingpong";

#------------------------------------------------------------
# The following simply concatenates the variables from above
# and throw in the : and @ characters.
# Do not alter them unless you want to change the default
# string to send along the Query String.
#------------------------------------------------------------

$FTPText  = "";
$HTTPText = "";

if ( ($FTPUsername  ne "" ) && ( $FTPPassword  ne "" ) ) { $FTPText  = $FTPUsername  . ":" . $FTPPassword  . "\@"; }
if ( ($HTTPUsername ne "" ) && ( $HTTPPassword ne "" ) ) { $HTTPText = $HTTPUsername . ":" . $HTTPPassword . "\@"; }

# ------------------------
# Initialize the perl libs
# ------------------------
  
use CGI;

&Initialize;

&RouteViaTheQueryString;

&Closure;

# ---------------------------------------------------------------------------

sub RouteViaTheQueryString {
  #------------------------------
  # Create a new cgi query module
  #------------------------------
  
  $query = new CGI;  
  
  $AdminMenu          = $query->param('adminmenu');
  $CheckPIN           = $query->param('checkpin');   
  $PIN                = $query->param('pin');
  $CalledID           = $query->param('session.calledid'); 
  $GetPIN             = $query->param('getpin');   
  $Message            = $query->param('message');
  $PlayMessage        = $query->param('playmessage');   
  $SaveMessage        = $query->param('savemessage');
  $DeleteMessage      = $query->param('deletemessage'); 
  $PlaySavedMessages  = $query->param('playsavedmessages'); 
  $WhichNumber        = $query->param('messagenumber');
  $UndeleteMessages   = $query->param('undeletemessages');   
  $ChangePIN          = $query->param('changepin');
  $ChangeGreeting     = $query->param('changegreeting'); 
  $SecondPass         = $query->param('secondpass');    
  $FinalPass          = $query->param('finalpass');
  $DeleteFiles        = $query->param('deletefiles'); 
  $AlreadyHeardNumber = $query->param('alreadyheardnumber'); 
  $TempGreetingFile   = $query->param('tempgreetingfile');
  $ShouldIHangup      = $query->param('shouldihangup');
  
  # -----------------------------------------------------------------
  # If there is no PIN code, then CheckPIN is automatically set to no
  # -----------------------------------------------------------------
  
  if ($PIN eq "") { $CheckPIN = "no"; }
  
  # -----------------------------------------------------
  # We need to check to make sure some variables are set.
  # Now, at present the greeting file is always 
  # "greeting" plus the session.called_id followed by 
  # a .wav extension, but this architecture
  # allows us to impliment multiple greeting files
  # set via the admin menu in the future if need be.
  #
  # Also get the GreetingFile name, the user's PINCode,
  # and NextMessage number via the user.ini file
  # ----------------------------------------------------
  
  &GetUserInformation;
  
  #----------------------------------------------------------
  # If there is no called id, then we have to abort voicemail
  #----------------------------------------------------------
  
  if ($CalledID eq "") {
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "VoicemailUnavailable.wav\" " .
          "termdigits=\"\" " .
          "cleardigits=\"FALSE\"/>";     
  }  # if statement
  
  # -------------------------------------------------------------------
  # Do the actual routing to subroutines depending on the URL variables
  # -------------------------------------------------------------------  
  
  elsif ($AdminMenu        eq "yes") { &TheAdminMenu;        }
  elsif ($CheckPIN         eq "yes") { &CheckThePIN;         }
  elsif ($GetPIN           eq "yes") { &GetThePIN;           }
  elsif ($Message          eq "yes") { &SaveTheNewMessage;   }
  elsif ($PlayMessage      eq "yes") { &PlayTheMessages;     }
  elsif ($SaveMessage      eq "yes") { &SaveTheMessage;      }
  elsif ($DeleteMessage    eq "yes") { &DeleteTheMessage;    }
  elsif ($UndeleteMessages eq "yes") { &UndeleteTheMessages; }
  elsif ($ChangePIN        eq "yes") { &ChangeThePIN;        }
  elsif ($ChangeGreeting   eq "yes") { &ChangeTheGreeting;   }
  elsif ($DeleteFiles      eq "yes") { &DeleteTheFiles;      }
  else                               { &MainMenu;            }
  
}  # RouteViaTheQueryString subroutine

# ---------------------------------------------------------------------------

sub Initialize {
  # ---------------------------------------------------
  # Initiate the CallXML header scripts, including the 
  # answering of an inbound call 
  # ---------------------------------------------------

  print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  print "<callXML>\n";
}  # Initialize Subroutine

# ---------------------------------------------------------------------------

sub GetUserInformation {
  #----------------------------------------------------
  # The user file is keyed into the calledID because
  # the way Voicemail is currently set up, everyone
  # will have their own specific voicemail box number
  #----------------------------------------------------

  $File = $FilePath . $CalledID . "/user.ini";

  open TempFileHandle, $File;

  #----------------------------
  # Read the file into an array
  #----------------------------

  @FileArray = <TempFileHandle>;

  #---------------
  # Close the file
  #---------------

  close TempFileHandle;
  
  $HighestMessage = 1;
  $PINCode        = "";
  $GreetingFile   = "defaultgreeting.wav";
  
  foreach $FileVariable (@FileArray) {
    @TempArray = split /:/, $FileVariable;
	
	foreach $TempVariable (@TempArray) {
	  #-----------------------------------------------
	  # We are doing three things in this nested loop:
	  # (1) Determining the greeting file name
	  # (2) Determining the admin PIN code
	  # (3) Determining the Next Message number
	  #     in case a voicemail message is saved.
	  #-----------------------------------------------
	
	  if ($LastItem eq "Greeting") {
	    $GreetingFile = $TempVariable;
		$LastItem     = "";
	  }  # if statement
	  elsif ($LastItem eq "PIN") {
	    $PINCode  = $TempVariable;
		$LastItem = "";
	  }  # else if statement
	  elsif ($LastItem eq "Voicemail") {
	    #---------------------------------------------------
	    # We are keeping track of the highest message number
		# though, for now, we are ignoring the status of the
		# message (i.e., New, Saved, Read, Deleted).
		#---------------------------------------------------
	  
	    if ($TempVariable > $HighestMessage) { $HighestMessage = $TempVariable; }
		
	    $LastItem = "";
	  }  # else if statement
	  
	  #----------------------------------------------------
	  # We have to use a "last item" variable because
	  # the variables alternate between data and identifier
	  #----------------------------------------------------
	  
	  if    ( lc($TempVariable) eq "greeting file")     { $LastItem = "Greeting";  }
	  elsif ( lc($TempVariable) eq "pin code") 		    { $LastItem = "PIN";       }
	  elsif ( lc($TempVariable) eq "voicemail message") { $LastItem = "Voicemail"; }

	}  # foreach loop
  }  # foreach loop
  
  $NextMessage = $HighestMessage + 1; 
}  # GetUserInformation subroutine

# ---------------------------------------------------------------------------

sub MainMenu {
  print "<cleardigits/>";   
  
  # -----------------------------------------------------------------------
  # Play our greeting file which says something like "Welcome to Voicemail"
  # -----------------------------------------------------------------------

  print "<block label=\"GreetingMenu\" " .
        "repeat=\"1\" " .
        "cleardigits=\"TRUE\">";
  print "<playaudio format=\"audio/wav\" " .  
        "value=\"http://" . $HTTPText . $RecordPath . $CalledID . "/" . $GreetingFile . "\" " .
        "termdigits=\"*\" " .
        "cleardigits=\"TRUE\"/>";
		
  print "<ontermdigit value=\"*\">";
  print "<goto value=\"$Voicemail" . "?getpin=yes\" submit=\"*\"/>";
  print "</ontermdigit>";
		
		
  print "</block>";
  
  # ---------------------------------------------------------
  # Now we enter our actual recording of the voicemail "menu"
  # i.e., we record the message, but allow the user to hop
  # to the Admin Menu on the pressing of *
  # ---------------------------------------------------------
  
  print "<block label=\"RecordMenu\" " .
        "repeat=\"1\" " .
		"cleardigits=\"TRUE\">";

  # -------------------------------------------------------
  # Play our "Record at the tone, press * for more options, 
  # or press # after the message" file.
  # -------------------------------------------------------
		
  print "<playaudio format=\"audio/wav\" " .  
        "value=\"$AudioPath" . "MainMessage.wav\" " .
        "termdigits=\"*\" " .
        "cleardigits=\"TRUE\"/>";
		
  print "<cleardigits/>";
		
  # -----------------------
  # Do the actual recording
  # -----------------------
  
  print "<recordaudio format=\"audio/wav\" " .  
        "value=\"ftp://" . $FTPText . $RecordPath . $CalledID . "/" . $NextMessage . ".wav\" " .
        "termdigits=\"#*\" " .
		"beep=\"TRUE\" " .
        "cleardigits=\"TRUE\" " .
	    "maxtime=\"180s\" " .
	    "maxsilence=\"30s\" />\n"; 
		
  # -----------------------------------------
  # On a hangup or a # key, save the message, 
  # on a * go to the AdminMenu
  # -----------------------------------------		 
		
  print "<onhangup>";
  print "<goto value=\"$Voicemail" . "?message=yes\" submit=\"*\"/>";
  print "</onhangup>";
  
  print "<onmaxsilence>";
  print "<playaudio format=\"audio/wav\" " . 
    	"value=\"$AudioPath" . "MaxSilenceHangup.wav\"/>";
  print "<goto value=\"$Voicemail" . "?message=yes\" submit=\"*\"/>";
  print "</onmaxsilence>";  
  
  # -------------------------------------------------------------
  # Give the user a little "Your message has been saved message."
  # -------------------------------------------------------------
  
  print "<ontermdigit value=\"#\">";
  print "<playaudio format=\"audio/wav\" " .  
        "value=\"$AudioPath" . "YourMessageHasBeenSaved.wav\" " .
        "termdigits=\"\" " .
        "cleardigits=\"FALSE\"/>";  
  print "<goto value=\"$Voicemail" . "?message=yes\" submit=\"*\"/>";
  print "</ontermdigit>"; 
  
  # -----------------------------------------------
  # Pressing the * key takes us into the AdminMenu. 
  # But first, we need to enter a PIN code.
  # ----------------------------------------------- 
  
  print "<ontermdigit value=\"*\">";
  print "<goto value=\"$Voicemail" . "?getpin=yes\" submit=\"*\"/>";
  print "</ontermdigit>";
  
  print "<onerror>";
  print "<playaudio format=\"audio/wav\" value=\"$AudioPath" . "ErrorDuringSave.wav\"/>";
  print "</onerror>";  
		
  print "</block>";
}  # Main Menu subroutine

# ---------------------------------------------------------------------------

sub GetThePIN {
  print "<cleardigits/>";   

  # ----------------------------------------------
  # Play our Enter PIN message and grab the digits
  # ----------------------------------------------
	
  print "<inputdigits label=\"PINNumber\" " .
        "repeat=\"3\" " .
        "var=\"pin\" " .
        "format=\"audio/wav\" " .
        "value=\"$AudioPath" . "GetPIN.wav\" " .
        "termdigits=\"#\" " .
        "cleardigits=\"TRUE\" " .
        "includetermdigit=\"FALSE\" " .
        "maxdigits=\"7\" " .
        "maxtime=\"20s\" " .
        "maxsilence=\"7s\">";
		
  # --------------------------------------------------------
  # Even if they hit too many digits, proceed forward with
  # the PIN number they used (which will probably be wrong).
  # --------------------------------------------------------
		  
  print "<onmaxdigits>";
  print "<goto value=\"$Voicemail" . "?checkpin=yes\" submit=\"*\"/>";
  print "</onmaxdigits>";
  
  &PrintOnMaxtimeHandler;
  
  print "<onmaxsilence>";
  print "<playaudio format=\"audio/wav\" " . 
  		"value=\"YouHaveTakenTooMuchTime.wav\"/>";
  print "<goto value=\"$Voicemail" . "\" submit=\"*\"/>";		
  print "</onmaxsilence>";
  
  #-----------------------------------------------------------
  # Clean up any files that might need to be deleted (possibly
  # from an earlier session).
  #-----------------------------------------------------------
  
  print "<onhangup>";
  print "<goto value=\"$Voicemail" . "?deletefiles=yes\" submit=\"*\"/>";  
  print "</onhangup>";
  
  print "<ontermdigit value=\"#\">";
  print "<goto value=\"$Voicemail" . "?checkpin=yes\" submit=\"*\"/>";
  print "</ontermdigit>";
  
  print "</inputdigits>";
}  # GetPIN subroutine

# ---------------------------------------------------------------------------

sub Closure {
  if ($ShouldIHangup ne "no") {
    print "<hangup/>";
  }  # if statement
  
  print "</callXML>\n";
}  # Closure subroutine

# ---------------------------------------------------------------------------

sub PrintOnMaxtimeHandler {
  # -----------------------------------------------
  # If time has expired, then let the user know and
  # hop back to the main menu
  # -----------------------------------------------
  
  print "<onmaxtime>";
  print "<playaudio format=\"audio/wav\" " .  
        "value=\"$AudioPath" . "YouHaveTakenTooMuchTime.wav\" " .
        "termdigits=\"\" " .
        "cleardigits=\"FALSE\"/>\n";	
		
  if ($MaxtimeToAdminMenu eq "yes") {
    print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
  }  # if statement
  else {
    print "<goto value=\"$Voicemail\" submit=\"*\"/>";
  }  # else statement
  print "</onmaxtime>";

}  # PrintOnMaxtimeHandler subroutine

# ---------------------------------------------------------------------------

sub TheAdminMenu {
  print "<cleardigits/>";   

  print "<block label=\"AdminMenu\" " .
      	"repeat=\"3\" " .
		"cleardigits=\"TRUE\">";
		
  print "<playaudio format=\"audio/wav\" " .  
        "value=\"$AudioPath" . "AdminMenu.wav\" " .
        "termdigits=\"12349*\" " .
        "cleardigits=\"FALSE\"/>\n";
  
  print "<ontermdigit value=\"1\">";
  print "<goto value=\"$Voicemail" . "?playmessage=yes\" submit=\"*\"/>";
  print "</ontermdigit>";
  	
  print "<ontermdigit value=\"2\">";
  print "<goto value=\"$Voicemail" . 
  		"?playmessage=yes&amp;playsavedmessages=yes\" submit=\"*\"/>"; 	
  print "</ontermdigit>";
  
  print "<ontermdigit value=\"3\">";
  print "<goto value=\"$Voicemail" . "?changepin=yes\" submit=\"*\"/>";
  print "</ontermdigit>";  
  
  print "<ontermdigit value=\"4\">";
  print "<goto value=\"$Voicemail" . "?changegreeting=yes\" submit=\"*\"/>";
  print "</ontermdigit>";  
  
  print "<ontermdigit value=\"9\">";
  print "<goto value=\"$Voicemail" . "?undeletemessages=yes\" submit=\"*\"/>";
  print "</ontermdigit>";  
  
  print "<ontermdigit value=\"*\">";
  print "<goto value=\"$Voicemail" . "\" submit=\"*\"/>";
  print "</ontermdigit>";
  
  print "<onhangup>";
  print "<goto value=\"$Voicemail" . "?deletefiles=yes\" submit=\"*\"/>";
  print "</onhangup>";  
		
  print "</block>";
  
  # --------------------------------------------
  # This audio file will only be executed if
  # we have looped through three complete times.
  # --------------------------------------------
  
  print "<playaudio format=\"audio/wav\" " .  
        "value=\"$AudioPath" . "HangingUp.wav\" " .
        "termdigits=\"\" " .
        "cleardigits=\"FALSE\"/>\n";
		
  print "<goto value=\"$Voicemail" . "?deletefiles=yes\" submit=\"*\"/>";		
}  # TheAdminMenu subroutine

# ---------------------------------------------------------------------------

sub CheckThePIN {
  #------------------------------------------------------------
  # "PINCode" is the user's actual PIN gathered from the
  # user.ini file.  "PIN" is the entered PIN via the telephone
  # which we are checking against.  The only reason "PINCode"
  # will be empty is if the user.ini file is missing or if
  # there was an error.  If such a circumstance occurs, then
  # we automatically declare the PIN invalid prevent the caller
  # from entering the Admin Menu.
  #------------------------------------------------------------
  
  if (($PINCode != $PIN) || ($PINCode == "")) {
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "InvalidPIN.wav\" " .
          "termdigits=\"\" " .
          "cleardigits=\"FALSE\"/>\n";
    print "<goto value=\"$Voicemail" . "\" submit=\"*\"/>";	
  }  # if statement
  else {
    print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";    
  }  # else statment
}  # CheckThePIN subroutine

# --------------------------------------------------------------------------

sub SaveTheNewMessage {
  #--------------------------------
  # Open the user.ini for appending
  #--------------------------------
  
  $File = $FilePath . $CalledID . "/user.ini";
 
  open TempFileHandle, ">>$File";
  
  #---------------------------------------------------------------
  # The format looks something like this:
  # Voicemail message:1:New
  #
  # The number is simply the message number that corresponds to a
  # file with the same name and a .wav extension.  In this example
  # it would be 1.wav
  #---------------------------------------------------------------
 
  print TempFileHandle "Voicemail message:" . $NextMessage . ":New\n";
  
  # --------------
  # Close our file
  # -------------- 
  
  close TempFileHandle;  
  
  #---------------------------------------
  # Just for cleanliness sake, we will see
  # if anything needs to be deleted.
  #---------------------------------------
 
  print "<goto value=\"$Voicemail" . "?deletefiles=yes&amp;shouldihangup=no\" submit=\"*\"/>";

}  # SaveTheNewMessage subroutine

# --------------------------------------------------------------------------

sub ChangeFolderStatus {
  # ----------------------------------------------------------------
  # Only change the status if there is a MessageNumber to work with.
  #
  # Just for clarification, "folder" is just a representation of
  # what is essentially a flag for the individual messages.  They 
  # are not literally placed in different folders on the server, the
  # user.ini file is simply altered.
  # ----------------------------------------------------------------
  
  if ($MessageToChange ne "") {
	  $File = $FilePath . $CalledID . "/user.ini";
	 
	  #--------------------------------
	  # Open the user.ini for reading
	  #-------------------------------- 
	 
	  open TempFileHandle, "$File";
	  
	  #-----------------------------------
	  # Read the entire file into an array
	  #-----------------------------------
	  
	  @TempArray = <TempFileHandle>;
	  
	  close TempFileHandle;
	
	  #--------------------------------
	  # Open the user.ini for writing
	  #--------------------------------  
	
	  open TempFileHandle, ">$File";
	  
	  $TempStr      = "";
      $MessageFound = "no";	    

	  foreach $Line (@TempArray) {
	    #--------------------------------------------------
	    # Check to see if this is the specific voicemail
		# message line we want. If it is, then replace it.
		#--------------------------------------------------
		
		$Position = index(lc($Line), "voicemail message:" . $MessageToChange . ":");
		
	    if ( $Position > -1 ) {

 		  $TempStr = "Voicemail message:" . $MessageToChange . 
		  					   ":" . $FolderStatus . "\n";							   
                  
	      #--------------------------------------
          # We want to save the just played saved
          # message for last so that we can loop
          # through the list.
		  #
		  # Also, we want to avoiding duplicating
		  # the deleted/saved record, so we make
		  # sure it can only be written once.
		  #--------------------------------------
		  
  		  if ($MessageFound eq "yes") {
		    if ($PlaySavedMessages ne "yes") { $TempStr = ""; }
			
		  }  # if statement
		  
		  if ($PlaySavedMessages ne "yes") {
		    print TempFileHandle $TempStr;
          }  # if statement
		  
		  $MessageFound = "yes";
		}  # if statement
		else {
	  	  print TempFileHandle $Line;	
		}  # else statement
	  }  # foreach loop

	  if ($PlaySavedMessages eq "yes") { print TempFileHandle $TempStr; }
	
	  # --------------
	  # Close our file
	  # -------------- 
	  
	  close TempFileHandle;	
  }  # if statement
}  # ChangeFolderStatus subroutine

# --------------------------------------------------------------------------

sub SaveTheMessage {
  print "<cleardigits/>";   

  $FolderStatus     = "Saved";
  $MessageToChange  = $WhichNumber;
  
  &ChangeFolderStatus;
  
  if ($PlaySavedMessages eq "yes") { $IncludeVariable = "&amp;playsavedmessages=yes"; }
  else                             { $IncludeVariable = "";                           }   
  
  print "<goto value=\"$Voicemail" . 
  	    "?playmessage=yes&amp;alreadyheardnumber=yes" .
		$IncludeVariable . "\" submit=\"*\"/>";
}  # SaveTheMessage subroutine

# --------------------------------------------------------------------------

sub DeleteTheMessage {
  print "<cleardigits/>";   

  #-------------------------------------------------------
  # Messages are flagged as deleted during a session
  # and deleted at the end of the session (more or less --
  # in fact, messages are deleted when a new voicemail
  # message is added and/or when a caller hangs up inside
  # the Admin Menu).  The messages can be "unflagged"
  # during the same call without the files actually being
  # deleted. 
  #-------------------------------------------------------

  $FolderStatus    = "Deleted";
  $MessageToChange = $WhichNumber;
  
  &ChangeFolderStatus;
   
  if ($PlaySavedMessages eq "yes") { $IncludeVariable = "&amp;playsavedmessages=yes"; }
  else                             { $IncludeVariable = "";                           }
  
  
  print "<playaudio format=\"audio/wav\" " .  
        "value=\"$AudioPath" . "MessageDeleted.wav\" " .
        "termdigits=\"\" " .
        "cleardigits=\"FALSE\"/>\n";   
  
  print "<goto value=\"$Voicemail" . 
  		"?playmessage=yes&amp;alreadyheardnumber=yes" . 
		$IncludeVariable . "\" submit=\"*\"/>";
}  # DeleteTheMessage subroutine

# --------------------------------------------------------------------------

sub UndeleteTheMessages {
  print "<cleardigits/>";   

  #----------------------------------------------
  # Like the Save and Delete message routines,
  # all we really do here is switch the "Deleted"
  # tag to "Saved".  No actual file movement.
  #----------------------------------------------

  $File = $FilePath . $CalledID . "/user.ini";
 
  #--------------------------------
  # Open the user.ini for reading
  #-------------------------------- 
 
  open TempFileHandle, "$File";
  
  @TempArray = <TempFileHandle>;
  
  close TempFileHandle;

  #--------------------------------
  # Open the user.ini for writing
  #--------------------------------  

  open TempFileHandle, ">$File";
  
  foreach $Line (@TempArray) {
    #------------------------------------------
    # Check to see if this is a deleted message
	# If it is, then replace "Deleted" with 
	# "Saved".
	#------------------------------------------
    
	$Position = index($Line, "Deleted");
	
    if (( $Position > -1) &&
	    (index($Line, "Voicemail message") > -1)) {
	  $TempString = substr($Line, 0, $Position);
	  print TempFileHandle $TempString . "Saved\n";
	}  # if statement
	else {
  	  print TempFileHandle $Line;	
	}  # else statement 
  }  # foreach loop

  # --------------
  # Close our file
  # -------------- 
  
  close TempFileHandle;
	
  print "<playaudio format=\"audio/wav\" " .  
        "value=\"$AudioPath" . "MessagesUndeleted.wav\" " .
        "termdigits=\"\" " .
        "cleardigits=\"FALSE\"/>\n"; 
		  
  print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
}  # UndeleteTheMessages subroutine

# --------------------------------------------------------------------------

sub PlayTheMessages {
  print "<cleardigits/>";   

  # ---------------------------------------------------
  # This routine is used for playing both saved and new
  # messages so we have to "load" the correct list.
  # ---------------------------------------------------
  
  if ($PlaySavedMessages eq "yes") { $SavedOrNew = "Saved"; }
  else 							   { $SavedOrNew = "New";   }
				  
  $File = $FilePath . $CalledID . "/user.ini";
 
  #--------------------------------
  # Open the user.ini for reading
  #-------------------------------- 
 
  open TempFileHandle, "$File";
  
  #-----------------------------------
  # Read the entire file into an array
  #-----------------------------------
  
  @TempArray = <TempFileHandle>;
  
  close TempFileHandle;
  
  $Loopy = 0;

  foreach $Line (@TempArray) {
    #--------------------------------------------
    # Check to see if this is a voicemail message
	# line.  If it is, then save it to the array.
	#--------------------------------------------
    
	$Position1 = index($Line, "Voicemail message");
	$Position2 = index($Line, $SavedOrNew);
	
    if ( ($Position1 > -1) && ($Position2 > -1) ) {
	  $Loopy        = $Loopy + 1;
	  $TempPosition = 0;
	  
	  #-------------------------------------------
	  # We have to extract the message file number
	  # from in between the two colons
	  #-------------------------------------------
	  
      ($Discard1, $TheMessages[$Loopy], $Discard2) = split /:/, $Line;
	}  # if statement
  }  # foreach loop

  # --------------
  # Close our file
  # -------------- 
  
  close TempFileHandle;	
  
  # -------------------------------------------------------
  # No need to tell the user/caller how many messages
  # there are every iteration, but the first time it should
  # be given.
  # -------------------------------------------------------
  
  if ($AlreadyHeardNumber ne "yes") {
	if ($Loopy == 1) { $TempStr = "message.";  }
	else             { $TempStr = "messages."; }  
	
	# ----------------------------------------------
	# Again, make sure we say "new" for new messages
	# and "saved" for saved messages.
	# ----------------------------------------------
	
	if ($PlaySavedMessages eq "yes") {
	  if ($Loopy > 0) {
	    print "<block>";
        print "<playaudio format=\"audio/wav\" " .  
              "value=\"$AudioPath" . "PlaySavedMessages.wav\" " .
              "termdigits=\"*\" " .
              "cleardigits=\"TRUE\"/>\n";
			  
		print "<ontermdigit value=\"*\">";
	    print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
		print "</ontermdigit>";
			  
		print "</block>";
	  }  # if statement
	
	  $TempStr = "You have " . $Loopy . " saved " . $TempStr;
	}  # if statement
	else {
 	  $TempStr = "You have " . $Loopy . " new " . $TempStr;
	}  # else statement
	
	
	if ($Loopy > 0) {
	  print "<text>";
	  print $TempStr;
      print "</text>";  	
	}  # if statement
  }  # if statement
  
  if ($Loopy ge 1) {
  
    if ($PlaySavedMessages ne "yes") {
      # ------------------------------------------------------------
      # Here we change the folder status from "New" to "Saved"
	  # by default.  If the user wants to Delete that message
	  # later, then fine.  Note that we originally had a fourth
	  # tag called "Read" that was an inbetween folder category
	  # but it was removed.  Technically you could replace the
	  # FolderStatus value directly below to a fourth tag if
	  # you wanted a slightly more robust method of saving messages.
	  # ------------------------------------------------------------
	  
	  $FolderStatus     = "Saved";
	  $MessageToChange  = $TheMessages[1];
	  &ChangeFolderStatus;
    }  # if statement
	
    print "<block label=\"PlayingMessage\" " .
          "repeat=\"1\" " .
  		  "cleardigits=\"TRUE\">";
		
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"http://" . $HTTPText . $RecordPath . $CalledID . "/" . $TheMessages[1] . ".wav\" " .
          "termdigits=\"12*\" " .
          "cleardigits=\"FALSE\"/>\n";  
		  
	#------------------------------------
	# Event handling routines for the XML
	# Pressing 1 Deletes the message
	# Pressing 2 Saves   the message
	#------------------------------------
	
	if ($PlaySavedMessages eq "yes") { $IncludeVariable = "&amp;playsavedmessages=yes"; }
	else                             { $IncludeVariable = "";                           }
  
    print "<ontermdigit value=\"1\">";
    print "<goto value=\"$Voicemail" . "?deletemessage=yes&amp;messagenumber=" . 
		  $TheMessages[1] . $IncludeVariable . "&amp;alreadyheardnumber=yes\" submit=\"*\"/>";
    print "</ontermdigit>";
	
	#----------------------------------------------------------
	# Playing saved messages shuffles the order, so we have to
	# go to the SaveTheMessage routine.  Otherwise, it defaults
	# to being saved anyway, so skip back to PlayMessage.
	#----------------------------------------------------------
	
	if ($PlaySavedMessages eq "yes") { 
	  $TempStr = "?savemessage=yes&amp;messagenumber=" . 
		  		 $TheMessages[1] . "&amp;playsavedmessages=yes&amp;alreadyheardnumber=yes";
	}  # if statement
	else {
	  #-----------------------------------------------------------------------
	  # Note, the NumMessages variable below is never used.  It is a method
	  # of getting around the HTTP caching used by the AGS.  Because we were
	  # calling the identical URL, we would end up looping as a result because
	  # the page was not reloading.  By altering the URL with a dummy variable,
	  # we bypass this problem.
	  #------------------------------------------------------------------------
	
	  $TempStr = "?playmessage=yes&amp;alreadyheardnumber=yes&amp;" . 
	  		     "nummessages=" . $Loopy;
	}  # else statement
  
    print "<ontermdigit value=\"2\">";
	print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "MessageSaved.wav\" " .
          "termdigits=\"\" " .
          "cleardigits=\"FALSE\"/>\n";	
    print "<goto value=\"$Voicemail" . $TempStr . "\" submit=\"*\"/>";
    print "</ontermdigit>";
	
	print "<ontermdigit value=\"*\">";
	print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
	print "</ontermdigit>";		
	
	print "</block>";
	
    print "<block label=\"MessageMenu\" " .
          "repeat=\"3\" " .
      	  "cleardigits=\"TRUE\">";

    print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "MessageMenu.wav\" " .
          "termdigits=\"12*\" " .
          "cleardigits=\"FALSE\"/>\n";	
		  	  
    print "<ontermdigit value=\"1\">";
    print "<goto value=\"$Voicemail" . "?deletemessage=yes&amp;messagenumber=" . 
		  $TheMessages[1] . $IncludeVariable . "&amp;alreadyheardnumber=yes\" submit=\"*\"/>";
    print "</ontermdigit>";
	
    print "<ontermdigit value=\"2\">";
	print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "MessageSaved.wav\" " .
          "termdigits=\"\" " .
          "cleardigits=\"FALSE\"/>\n"; 
    print "<goto value=\"$Voicemail" . $TempStr . "\" submit=\"*\"/>";
    print "</ontermdigit>";
  
	print "<ontermdigit value=\"*\">";
	print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
	print "</ontermdigit>";	
	
	print "<wait value=\"7s\" termdigits=\"12*\"/>";

	print "</block>";
  }  # if statement
  else {
    # ------------------------------------------
    # If there are no new messages, we will play
	# a prompt and then return to the AdminMenu
	# ------------------------------------------
    
	if ($PlaySavedMessages eq "yes") {
	  $AudioFile = "NoSavedMessages.wav";
	}  # if statement
	else {
	  $AudioFile = "NoNewMessages.wav";
	}  # else statement
	
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . $AudioFile . "\" " .
          "termdigits=\"\" " .
          "cleardigits=\"FALSE\"/>\n"; 
		  
	print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";  
  }  # else statement 
}  # PlayTheMessages subroutine

# --------------------------------------------------------------------------

sub ChangeThePIN {
  print "<cleardigits/>";   

  # --------------------------------------------------
  # The "FinalPass" through means we are going to save
  # the new PIN and redirect back to the Admin menu
  # --------------------------------------------------
  
  if ($FinalPass eq "yes") {
    # -----------------------------------------------
    # If for some reason we did not get a PIN number
	# then pop up our generic "There was an error in
	# voicemail message and exit.
	# -----------------------------------------------
    
    if ($PIN eq "") {
      print "<playaudio format=\"audio/wav\" " .  
            "value=\"$AudioPath" . "VoicemailUnavailable.wav\" " .
            "termdigits=\"\" " .
            "cleardigits=\"FALSE\"/>";  
	}  # if statement
    else {
	  $File = $FilePath . $CalledID . "/user.ini";
	 
	  #--------------------------------
	  # Open the user.ini for reading
	  #-------------------------------- 
	 
	  open TempFileHandle, "$File";
	  
	  #-----------------------------------
	  # Read the entire file into an array
	  #-----------------------------------
	  
	  @TempArray = <TempFileHandle>;
	  
	  close TempFileHandle;
	
	  #--------------------------------
	  # Open the user.ini for writing
	  #--------------------------------  
	
	  open TempFileHandle, ">$File";
	  
	  foreach $Line (@TempArray) {
	    #------------------------------------------
	    # Check to see if this is the PIN Code
		# line.  If it is, then replace it
		#------------------------------------------
	    
		$Position = index($Line, "PIN code");
		
	    if ( $Position > -1 ) {
		  print TempFileHandle "PIN code:" . $PIN . "\n";
		}  # if statement
		else {
	  	  print TempFileHandle $Line;	
		}  # else statement
	 
	  }  # foreach loop
	
	  # --------------
	  # Close our file
	  # -------------- 
	  
	  close TempFileHandle;	
	  
	  # ---------------------------------------
	  # Inform the user/caller the PIN has been
	  # changed and hop back to the Admin Menu
	  # ---------------------------------------
	  
      print "<playaudio format=\"audio/wav\" " .  
            "value=\"$AudioPath" . "PINHasBeenChanged.wav\" " .
            "termdigits=\"\" " .
            "cleardigits=\"FALSE\"/>"; 	  
	  
	  print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
	}  # else statement
  }  # if statement
  elsif ($SecondPass eq "yes") {
    # ----------------------------------------------
	# The entire "SecondPass" essentially plays back
	# the "new" PIN and asks the user/caller if she
	# wants to keep this PIN, enter a different PIN
	# or return to the Admin menu.
	# ----------------------------------------------
	
	if ($PIN eq "") {
	  print "<playaudio format=\"audio/wav\" " .  
	        "value=\"$AudioPath" . "YouHaveEnteredInvalidPIN.wav\" " .
	        "termdigits=\"\" " .
	        "cleardigits=\"FALSE\"/>\n";
			
	  print "<goto value=\"$Voicemail" . "?changepin=yes\" submit=\"*\"/>"; 
	}
	else {
	  print "<block label=\"PINSecondPass\" " .
	        "repeat=\"3\" " .
	 	    "cleardigits=\"TRUE\">";
		  
	  print "<playaudio format=\"audio/wav\" " .  
	        "value=\"$AudioPath" . "YouHaveEnteredPIN.wav\" " .
	        "termdigits=\"\" " .
	        "cleardigits=\"FALSE\"/>";
		  
	  print "<playnumber format=\"digits\" " .
	 	    "value=\"$PIN" . "\" " .		
		    "termdigits=\"\" " .
		    "cleardigits=\"TRUE\"/>";
		   
	  print "<playaudio format=\"audio/wav\" " .  
	        "value=\"$AudioPath" . "KeepThisPIN.wav\" " .
	        "termdigits=\"12*\" " .
	        "cleardigits=\"FALSE\"/>"; 
	 
	  print "<ontermdigit value=\"1\">";
	  print "<goto value=\"$Voicemail" . "?changepin=yes&amp;finalpass=yes&amp;" .
		    "pin=" . $PIN . "\" submit=\"*\"/>";
	  print "</ontermdigit>";		  
	
	  print "<ontermdigit value=\"2\">";
	  print "<goto value=\"$Voicemail" . "?changepin=yes\" submit=\"*\"/>";
	  print "</ontermdigit>";	 	
	
	  print "<ontermdigit value=\"*\">";
	  print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
 	  print "</ontermdigit>";			  
	  
	  print "<wait value=\"7s\" termdigits=\"12*\"/>";
		  
	  print "</block>";    
	}  # else statement
  }  # elseif statement
  else {
    # ----------------------------------------------
    # Play our Enter PIN message and grab the digits
    # ----------------------------------------------
	
    print "<inputdigits label=\"ChangePIN\" " .
          "repeat=\"3\" " .
          "var=\"pin\" " .
          "format=\"audio/wav\" " .
          "value=\"$AudioPath" . "ChangePIN.wav\" " .
          "termdigits=\"#*\" " .
          "cleardigits=\"TRUE\" " .
          "includetermdigit=\"FALSE\" " .
          "maxdigits=\"7\" " .
          "maxtime=\"20s\" " .
          "maxsilence=\"7s\">";
		
    # --------------------------------------------------------
    # Even if they hit too many digits, proceed forward with
    # the PIN number they used.
    # --------------------------------------------------------
		  
    print "<onmaxdigits>";
    print "<goto value=\"$Voicemail" . "?changepin=yes&amp;secondpass=yes\" submit=\"*\"/>";
    print "</onmaxdigits>";
    
    $MaxtimeToAdminMenu = "yes";  
    &PrintOnMaxtimeHandler;
	
    print "<onmaxsilence>";
    print "<playaudio format=\"audio/wav\" " . 
  		  "value=\"$AudioPath" . "YouHaveTakenTooMuchTime.wav\"/>";
	print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
    print "</onmaxsilence>";
  
    #-----------------------------------------------------------
    # Clean up any files that might need to be deleted (possibly
    # from an earlier session).
    #-----------------------------------------------------------
  
    print "<onhangup>";
    print "<goto value=\"$Voicemail" . "?deletefiles=yes\" submit=\"*\"/>";  
    print "</onhangup>";	
  
    print "<ontermdigit value=\"#\">";
    print "<goto value=\"$Voicemail" . "?changepin=yes&amp;secondpass=yes\" submit=\"*\"/>";
    print "</ontermdigit>";
  
    print "<ontermdigit value=\"*\">";
    print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
    print "</ontermdigit>";
  
    print "</inputdigits>";  
  }  # else statement
}  # ChangeThePIN subroutine

# --------------------------------------------------------------------------

sub ChangeTheGreeting {
  print "<cleardigits/>";   

  # --------------------------------------------------------
  # The "FinalPass" through means we are going to save
  # the new GreetingFile and redirect back to the Admin menu
  # --------------------------------------------------------
  
  if ($FinalPass eq "yes") {
	# ------------------------------------------------------------------------
	# Change the GreetingFile name
	#
	# The current method is simply to give the greeting file the number of the
	# CalledID.  Thus voicemail box number 555-1234's greeting file would 
	# be Greeting5551234.wav.  This could obviously change at somepoint.
	# In fact, it isn't even necessary to alter the user.ini file like
	# we are below, but if you used multiple greetingfile names for
	# some reason, the code is in place to do it.
	# -------------------------------------------------------------------------
	  
	use File::Copy;
	
    #-----------------------------------------------------------
    # This is a cache killer, otherwise the AGS will not reload
	# the updated greeting file.
    #-----------------------------------------------------------  
  
    $Position = index($GreetingFile, "-1-");
	
    if ($Position > -1) { $TempString = "-2-"; }
	else                { $TempString = "-1-"; }
	
    copy($FilePath . $CalledID . "/" . $TempGreetingFile, 
		 $FilePath . $CalledID . "/Greeting" . $CalledID . $TempString . ".wav");
		 
	$File = $FilePath . $CalledID . "/user.ini";
	
	#--------------------------------
	# Open the user.ini for reading
	#-------------------------------- 
	
	open TempFileHandle, "$File";
	
	@TempArray = <TempFileHandle>;
	
	close TempFileHandle;
	
	#--------------------------------
	# Open the user.ini for writing
	#--------------------------------  
	
	open TempFileHandle, ">$File";
	
	foreach $Line (@TempArray) {
	  #------------------------------------------
	  # Check to see if this is the PIN Code
	  # line.  If it is, then replace it
	  #------------------------------------------
	  
	  $Position = index($Line, "Greeting file");
	
	  if ( $Position > -1 ) {
	    print TempFileHandle "Greeting file:Greeting". $CalledID . $TempString . ".wav\n";
	  }  # if statement
	  else {
	    print TempFileHandle $Line;	
	  }  # else statement
	}  # foreach loop
	
	# --------------
	# Close our file
	# -------------- 
	
	close TempFileHandle;		 

	# ---------------------------------------
	# Inform the user/caller the PIN has been
	# changed and hop back to the Admin Menu
	# ---------------------------------------
	  
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "GreetingFileHasBeenChanged.wav\" " .
          "termdigits=\"\" " .
          "cleardigits=\"FALSE\"/>"; 	  
	  
	print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
  }  # if statement
  elsif ($SecondPass eq "yes") {
    # ------------------------------------------------------
	# The entire "SecondPass" essentially plays back
	# the "new" GreetingFile and asks the user/caller if she
	# wants to keep this Greetingfile, enter a different
	# GreetingFile or return to the Admin menu.
	# -----------------------------------------------------
    
    print "<block label=\"GreetingSecondPass\" " .
          "repeat=\"3\" " .
  		  "cleardigits=\"TRUE\">";
		  
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "YouHaveEnteredGreeting.wav\" " .
          "termdigits=\"\" " .
          "cleardigits=\"FALSE\"/>\n";
		  
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"http://" . $HTTPText . $RecordPath . $CalledID . "/" . $TempGreetingFile . "\" " .
          "termdigits=\"12*\" " .
          "cleardigits=\"FALSE\"/>\n"; 
		  
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "KeepThisGreeting.wav\" " .
          "termdigits=\"12*\" " .
          "cleardigits=\"FALSE\"/>\n"; 
  
    print "<ontermdigit value=\"1\">";
    print "<goto value=\"$Voicemail" . "?changegreeting=yes&amp;finalpass=yes&amp;" .
		  "tempgreetingfile=" . $TempGreetingFile . "\" submit=\"*\"/>";
    print "</ontermdigit>";		  
	
    print "<ontermdigit value=\"2\">";
    print "<goto value=\"$Voicemail" . "?changegreeting=yes\" submit=\"*\"/>";
    print "</ontermdigit>";	 	
	
	print "<ontermdigit value=\"*\">";
	print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
	print "</ontermdigit>";			  
	
	print "<wait value=\"5s\" termdigits=\"12*\"/>";
		  
	print "</block>";    
  }  # elseif statement
  else {
    # -----------------------------------------------------------
    # Play our Enter new Greeting message and record the greeting
    # -----------------------------------------------------------
	
 	print "<block label=\"ChangeGreeting\" " .
		  "repeat=\"1\" " .
		  "cleardigits=\"TRUE\">";
		  
    # -------------------------------------------------------
    # Play our "Record at the tone, press * for more options, 
    # or press # after the message" file.
    # -------------------------------------------------------
		
    print "<playaudio format=\"audio/wav\" " .  
          "value=\"$AudioPath" . "ChangeGreeting.wav\" " .
          "termdigits=\"*\" " .
          "cleardigits=\"TRUE\"/>";
		  
    # -----------------------------------------------------------------------
    # Seed the random number generator for generating a random temp file name
	# this is to avoid the sometimes annoying cache feature
    # -----------------------------------------------------------------------
  
    srand;
  
    # ------------------------------------------------ 												  
    # We simply append a new random digit onto the end	  
    # for each pass through this file.								  
    # ------------------------------------------------
  
    $TempGreetingFile = "";
	
	while (length($TempGreetingFile) < 8) {
      $RandomNumber     = rand(10);
      $RandomNumber     = substr($RandomNumber,0,1); 
      $TempGreetingFile = $TempGreetingFile . $RandomNumber;
    }  # while loop
	
	$TempGreetingFile = $TempGreetingFile . ".wav";
		
    # -----------------------
    # Do the actual recording
    # -----------------------
  
    print "<recordaudio format=\"audio/wav\" " .  
          "value=\"ftp://" . $FTPText . $RecordPath  . $CalledID . "/" . $TempGreetingFile . "\" " .
          "termdigits=\"#*\" " .
		  "beep=\"TRUE\" " .
          "cleardigits=\"TRUE\" " .
	      "maxtime=\"180s\" " .
	      "maxsilence=\"30s\" />\n";		  
		
    $MaxtimeToAdminMenu = "yes";  
    &PrintOnMaxtimeHandler;
	
    print "<onmaxsilence>";
    print "<playaudio format=\"audio/wav\" " . 
  		  "value=\"YouHaveTakenTooMuchTime.wav\"/>";
	print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
    print "</onmaxsilence>";	
  
    print "<ontermdigit value=\"#\">";
    print "<goto value=\"$Voicemail" . "?changegreeting=yes&amp;secondpass=yes" . 
		         "&amp;tempgreetingfile=" . $TempGreetingFile . "\" submit=\"*\"/>";
    print "</ontermdigit>";
  
    print "<ontermdigit value=\"*\">";
    print "<goto value=\"$Voicemail" . "?adminmenu=yes\" submit=\"*\"/>";
    print "</ontermdigit>";
	
    print "<onerror>";
    print "<playaudio format=\"audio/wav\" value=\"ErrorDuringGreeting.wav\"/>";
    print "</onerror>";  	
  
    print "</block>";  
  }  # else statement

}  # ChangeTheGreeting subroutine

# --------------------------------------------------------------------------

sub DeleteTheFiles {
	$File = $FilePath . $CalledID . "/user.ini";
	
	#--------------------------------
	# Open the user.ini for reading
	#-------------------------------- 
	
	open TempFileHandle, "$File";
	
	@TempArray = <TempFileHandle>;
	
	close TempFileHandle;
	
	#--------------------------------
	# Open the user.ini for writing
	#--------------------------------  
	
	open TempFileHandle, ">$File";
	
	foreach $Line (@TempArray) {
	  #---------------------------------------------
	  # Check to see if this is a deleted file
	  # If it is, then delete it and remove the line
	  # from the user.ini.
	  #---------------------------------------------
	  
	  $Position = index($Line, "Deleted");
	
	  if ( $Position > -1 ) {
	    ($Discard1, $TheFile, $Discard2) = split /:/, $Line;
		
		@FileList = $FilePath . $CalledID . "/" . $TheFile . ".wav";
		
	    unlink @FileList;
	  }  # if statement
	  elsif (length($Line) > 1) {
	    print TempFileHandle $Line;	
	  }  # else statement
	}  # foreach loop
	
	# --------------
	# Close our file
	# -------------- 
	
	close TempFileHandle;		 
}  # DeleteTheFiles subroutine
